// The contents of this file are subject to the Mozilla Public License Version 1.1
// (the "License"); you may not use this file except in compliance with the License.
// You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
// 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
// WARRANTY OF ANY KIND, either express or implied. See the License for the specific
// language governing rights and limitations under the License.
// 
// The Original Code is the Venice Web Communities System.
// 
// The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
// for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
// Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
// 
// Contributor(s): 

importPackage(Packages.com.silverwrist.venice.core);
importPackage(Packages.com.silverwrist.venice.except);
importPackage(Packages.com.silverwrist.venice.ui);
importPackage(Packages.com.silverwrist.venice.ui.dlg);
importPackage(Packages.com.silverwrist.venice.ui.helpers);
importPackage(Packages.com.silverwrist.venice.ui.view);

// get the request object and the community
rinput = bsf.lookupBean("request");
comm = rinput.getCommunity(true,"top.js.vs");

if (!(comm.canJoin()))
{ // you can't join the community
  vlib.output(new ErrorBox("Community Error","You are not permitted to join this community.","top.js.vs"));
  vlib.done();

} // end if

if (comm.isPublicCommunity())
{ // the community is public - attempt to join right away
  rc = null;
  try
  { // join the community!
    comm.join(null);

    // force the menus to be redrawn
    rinput.setSessionAttribute(RequestInput.LEFT_MENU_SESSION_ATTR,null);

    // create a return view
    rc = new JSPView("Welcome to " + comm.name,"comm/welcome.jsp");
    rc.menuSelector = Content.MENU_SELECTOR_COMMUNITY;

  } // end try
  catch (e)
  { // exception when we tried to join the community
    etype = vlib.exceptionType(e) + "";
    if (etype.match("AccessError"))
      rc = new ErrorBox("Access Error","Unable to join community: " + e.message,"top.js.vs");
    else if (etype.match("DataException"))
      rc = new ErrorBox("Database Error","Database error joining community: " + e.message,"top.js.vs");
    else
      rc = e;

  } // end catch

  vlib.output(rc);
  vlib.done();

} // end if

// Get the "join key" dialog.
dlg = rinput.getDialog("join");
dlg.setValue("cc",comm.communityID + "");
vlib.output(dlg);
